use serde::Serialize;

use super::macros::to_wasm;
use super::standard_properties::WasmStandardProperties;
use super::to_wasm::ToWasm;
use crate::types::Bold;
use crate::wasm::to_wasm::ToWasmStandardProperties;
use crate::wasm::WasmAstNode;

#[derive(Debug, Serialize)]
#[serde(tag = "ast_node")]
#[serde(rename = "org-data")]
pub struct WasmBold {
    standard_properties: WasmStandardProperties,
    children: Vec<WasmAstNode>,
}

to_wasm!(
    WasmBold,
    Bold<'s>,
    original,
    wasm_context,
    standard_properties,
    {
        Ok(WasmBold {
            standard_properties,
            children: Vec::new(),
        })
    }
);

impl Into<WasmAstNode> for WasmBold {
    fn into(self) -> WasmAstNode {
        WasmAstNode::Bold(self)
    }
}
