use serde::Serialize;

use super::macros::to_wasm;
use super::standard_properties::WasmStandardProperties;
use super::to_wasm::ToWasm;
use crate::types::TableCell;
use crate::wasm::to_wasm::ToWasmStandardProperties;
use crate::wasm::WasmAstNode;

#[derive(Debug, Serialize)]
#[serde(tag = "ast_node")]
#[serde(rename = "org-data")]
pub struct WasmTableCell {
    standard_properties: WasmStandardProperties,
    children: Vec<WasmAstNode>,
}

to_wasm!(
    WasmTableCell,
    TableCell<'s>,
    original,
    wasm_context,
    standard_properties,
    {
        Ok(WasmTableCell {
            standard_properties,
            children: Vec::new(),
        })
    }
);
